Index: /pjproject/trunk/RELNOTES.txt
===================================================================
--- /pjproject/trunk/RELNOTES.txt	(revision 47)
+++ /pjproject/trunk/RELNOTES.txt	(revision 48)
@@ -1,20 +1,27 @@
-Version 0.3
+RELEASE NOTES
+
+Version 0.3-pre4
+Nov 13th, 2005
+====================================
+
 PJLIB
-	- Correct error reporting in the whole library. No more vague -1 errors!
-	- New super portable socket abstraction.
-	- Other headers were made super portable too.
-	- Ioqueue supports multiple pending operations in a single socket!
-	- No more floating point.
-	- Ported to new platforms:
-		- i386/linux kernel (!)
-		- Sparc/Solaris
-		- Alpha/Linux
+ - Correct error reporting in the whole library. No more vague -1 errors!
+ - New super portable socket abstraction.
+ - Other headers were made super portable too.
+ - Ioqueue supports multiple pending operations in a single socket!
+ - No more floating point.
+ - Ported to new platforms:
+    - i386/linux kernel (!)
+    - Sparc/Solaris
+    - Alpha/Linux
+
 PJSIP
-	- Correct error reporting in the whole library. No more -1 errors!
-	- Rewrote event, now much more readable.
-	- Per object tracing.
+  - Correct error reporting in the whole library. No more -1 errors!
+  - Rewrote event, now much more readable.
+  - Per object tracing.
 
 
 Version 0.2.9 - 2005/06/19
+====================================
 Core:
   - Moved authentication stuff to core.
Index: /pjproject/trunk/pjlib/docs/doxygen.cfg
===================================================================
--- /pjproject/trunk/pjlib/docs/doxygen.cfg	(revision 47)
+++ /pjproject/trunk/pjlib/docs/doxygen.cfg	(revision 48)
@@ -134,5 +134,5 @@
 # the path. It is allowed to use relative paths in the argument list.
 
-STRIP_FROM_PATH        = "c:\project\pjproject-0.3"
+STRIP_FROM_PATH        = "c:\project\pjproject"
 
 # The INTERNAL_DOCS tag determines if documentation 
@@ -495,5 +495,5 @@
 # doxygen will generate files with .html extension.
 
-HTML_FILE_EXTENSION    = .html
+HTML_FILE_EXTENSION    = .htm
 
 # The HTML_HEADER tag can be used to specify a personal HTML header for 
Index: /pjproject/trunk/pjlib/docs/footer.html
===================================================================
--- /pjproject/trunk/pjlib/docs/footer.html	(revision 47)
+++ /pjproject/trunk/pjlib/docs/footer.html	(revision 48)
@@ -1,4 +1,9 @@
 </TD></TR>
 </TABLE>
+
+</td>
+</tr>
+</table>
+
 </BODY>
 </HTML>
Index: /pjproject/trunk/pjlib/docs/header.html
===================================================================
--- /pjproject/trunk/pjlib/docs/header.html	(revision 47)
+++ /pjproject/trunk/pjlib/docs/header.html	(revision 48)
@@ -4,7 +4,29 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 </head><body>
-<A HREF="/">&lt;-- HOME</A><HR>
 
+<TABLE id="MainTable" cellSpacing="0" cellPadding="0" width="100%" border="0">
+<!-- First Row, PJPROJECT logo. -->
+<TR>
+    <TD>
+	<TABLE id="LogoTable" cellSpacing="0" cellPadding="0" width="100%" border="0">
+	    <TR>
+		<TD><a href="/" target="_top"><IMG src="/images/pjlogo.jpg" border="0"></a></TD>
+		<TD>&nbsp;</TD>
+		<TD>&nbsp;</TD>
+	    </TR>
+	</TABLE>
+    </TD>
+</TR>
+<!-- Second Row, a HR. -->
+<TR>
+    <td colspan="3"><hr noshade size="1">
+    </td>
+</TR>
+<!-- Third row, main contents. -->
+<TR>
+    <TD>
+
+<!-- Main doxygen content -->
 <TABLE border="0">
-  <TR><TD width="600" align="left">
+  <TR><TD width="800" align="left">
 
Index: /pjproject/trunk/pjlib/include/pj/doxygen.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/doxygen.h	(revision 47)
+++ /pjproject/trunk/pjlib/include/pj/doxygen.h	(revision 48)
@@ -30,5 +30,5 @@
  *
  * PJLIB and all documentation can be downloaded from 
- * http://www.bulukucing.org.
+ * http://www.pjproject.net.
  *
  *
@@ -238,9 +238,4 @@
  *
  *
- * @subsection lexical_scanner_sec Lexical Scanner
- *
- * A fast, small, top-down lexical scanner to create fully optimized
- * hand-written parser. See @ref PJ_SCAN for more info.
- *
  * @subsection data_struct_sec Various Data Structures
  *
@@ -258,5 +253,5 @@
  * A convenient TRY/CATCH like construct to propagate errors, which by
  * default are used by the @ref PJ_POOL_GROUP "memory pool" and 
- * the @ref PJ_SCAN "scanner". The exception
+ * the lexical scanner in pjlib-util. The exception
  * construct can be used to write programs like below:
  *
@@ -394,5 +389,5 @@
  * Enjoy using PJLIB!
  *
- * Benny Prijono < bennylp at bulukucing dot org >
+ * Benny Prijono < bennylp at pjproject dot net >
  */
 